#!/bin/sh
# $Id: t-t2821-4.sh,v 1.1 2007/11/11 06:45:39 ca Exp $
#

test -s stop && exit 1

ERRORS=0
IN=t2821_parse.in
OUT=t2821_parse.out
ERR=t2821_parse.err
ERRORS=0

# local part + detail: keep quotes if required by RFC 2821
TEST=1
./t-t2821-1 -d'/_' -D $@ > ${OUT} 2> ${ERR} <<EOF
<l@b.c>
<l_@b.c>
<_x@b.c>
<l_x@b.c>
<_x@b.c>
<"l_x"@b.c>
<"l_x@z"@b.c>
<l_x+y@b.c>
<"l_x z"@b.c>
<l/x_y@b.c>
EOF

cat > ${IN} <<EOF
>>><l@b.c><<<
OK	>>><l@b.c><<<
<l@b.c>
local=l, detail=
>>><l_@b.c><<<
OK	>>><l_@b.c><<<
<l_@b.c>
local=l, detail=
>>><_x@b.c><<<
OK	>>><_x@b.c><<<
<_x@b.c>
local=, detail=x
>>><l_x@b.c><<<
OK	>>><l_x@b.c><<<
<l_x@b.c>
local=l, detail=x
>>><_x@b.c><<<
OK	>>><_x@b.c><<<
<_x@b.c>
local=, detail=x
>>><"l_x"@b.c><<<
OK	>>><"l_x"@b.c><<<
<l_x@b.c>
local=l, detail=x
>>><"l_x@z"@b.c><<<
OK	>>><"l_x@z"@b.c><<<
<"l_x@z"@b.c>
local=l_x@z, detail=
>>><l_x+y@b.c><<<
OK	>>><l_x+y@b.c><<<
<l_x+y@b.c>
local=l, detail=x+y
>>><"l_x z"@b.c><<<
OK	>>><"l_x z"@b.c><<<
<"l_x z"@b.c>
local=l_x z, detail=
>>><l/x_y@b.c><<<
OK	>>><l/x_y@b.c><<<
<l/x_y@b.c>
local=l, detail=x_y
EOF
diff ${OUT} ${IN}
if test $? -ne 0
then
  echo "$0: test ${TEST} failed"
  ERRORS=`expr ${ERRORS} + 1`
fi

# local part + detail: remove quotes
TEST=2
./t-t2821-1 -q -d"/_" -D $@ > ${OUT} 2> ${ERR} <<EOF
<"l"@b.c>
<l@b.c>
<l_@b.c>
<l_x@b.c>
<_x@b.c>
<"l_x"@b.c>
<"l_x@z"@b.c>
<l_x+y@b.c>
<"l_x z"@b.c>
EOF

cat > ${IN} <<EOF
>>><"l"@b.c><<<
OK	>>><"l"@b.c><<<
<l@b.c>
local=l, detail=
>>><l@b.c><<<
OK	>>><l@b.c><<<
<l@b.c>
local=l, detail=
>>><l_@b.c><<<
OK	>>><l_@b.c><<<
<l_@b.c>
local=l, detail=
>>><l_x@b.c><<<
OK	>>><l_x@b.c><<<
<l_x@b.c>
local=l, detail=x
>>><_x@b.c><<<
OK	>>><_x@b.c><<<
<_x@b.c>
local=, detail=x
>>><"l_x"@b.c><<<
OK	>>><"l_x"@b.c><<<
<l_x@b.c>
local=l, detail=x
>>><"l_x@z"@b.c><<<
OK	>>><"l_x@z"@b.c><<<
<"l_x@z"@b.c>
local=l, detail=x@z
>>><l_x+y@b.c><<<
OK	>>><l_x+y@b.c><<<
<l_x+y@b.c>
local=l, detail=x+y
>>><"l_x z"@b.c><<<
OK	>>><"l_x z"@b.c><<<
<"l_x z"@b.c>
local=l, detail=x z
EOF
diff ${OUT} ${IN}
if test $? -ne 0
then
  echo "$0: test ${TEST} failed"
  ERRORS=`expr ${ERRORS} + 1`
fi

exit ${ERRORS}
