/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: tr_simple.c,v 1.2 2010/12/25 22:31:06 ca Exp $")

#include "sm/string.h"
#include "sm/misc.h"

/*
**  TR_SIMPLE -- replace all occurrences of a char in repl in str
**				with corresponding char in with [simple version of tr(1)]
**
**	Parameters:
**		str -- string to be converted
**		repl -- list of chars to be replaced
**		with -- list of chars act as replacement
**
**	Returns:
**		nothing
*/

void
tr_simple(char *str, const char *repl, const char *with)
{
	char *s, *in;
	size_t l;

	if (NULL == str || NULL == repl || NULL == with)
		return;
	l = strlen(repl);
	SM_ASSERT(strlen(with) == l);
	s = str;
	while (*s != '\0') {
		if ((in = strchr(repl, *s)) != NULL)
			*s = *(with + (in - repl));
		++s;
	}
}

