#!/bin/sh
# $Id: t-exit-0.sh,v 1.12 2013/12/23 00:08:31 ca Exp $
# Copyright (c) 2004 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test restart: don't restart program because of EX_USAGE exit code
# ----------------------------------------
#

CONF=exit.conf
CNTF=exit.cnt

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
. ${SD}/common.sh


rm -f ${PIDS} ${OUT} ${CNTF}
echo 0 > ${CNTF}
cat > ${CONF} <<EOF
exit {
	start_action = wait;
	processes_min = 1;
	processes_max = 1;
	user = ${USER};
	path = ./t-exit;
	arguments = "t-exit -f ${CNTF} -s 1";
}
EOF
./mcp -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}
sleep 3

chkr ${CNTF} 1
fgrep "exit=command line usage error" >/dev/null ${OUT} || ERRS=`expr ${ERRS} + 1 `
fgrep "status=server failed with unrecoverable error; service terminated" >/dev/null ${OUT} || ERRS=`expr ${ERRS} + 1 `

stopit

exit ${ERRS}
