#!/bin/sh
# $Id: smtpp.sh,v 1.4 2013/11/25 01:58:42 ca Exp $
#
# running SMTP server and client with PIPELINING
#
# source directory of this (and other) shell script
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../../statethreads/examples
fi
. $SD/../../chkmts/paths.sh

# host on which to listen/to which to send
H=localhost
# port number to use
P=${MTA_SRVPORT:-1235}
ERRS=0
SRVL="smtps.log"
CLTL="smtpc.log"
rm -f $SRVL $CLTL
#

SRV=smtps2
# start SMTP server
./$SRV -@ P -l . -b $H:$P > $SRVL 2>&1 &
status=$?
SRVPID=$!
if [ "x$status" != "x0" ]
then
  echo "FAIL: cannot start server $status"
  exit $status
fi
sleep 3
if grep "ERROR" $SRVL > /dev/null
then
  echo "found ERROR in $SRVL"
  ERRS=`expr $ERRS + 1 `
fi

THRDS=5
MSGS=20
if ./smtpc2 -d 8 -P -r $H:$P -m $MSGS -s $MSGS -t $THRDS > $CLTL 2>&1
then
  i=0
  while [ $i -lt $THRDS ]
  do
    if grep "^\[$i\] "  $CLTL | $AWK -f $SD/pcheck.awk
    then
      i=`expr $i + 1 `
    else
      echo "$0: found PIPELINING error [$i]"
      ERRS=`expr $ERRS + 1 `
      break
    fi
  done
else
  cat $CLTL
  ERRS=`expr $ERRS + 1 `
fi

# stop server
kill ${SRVPID}

if [ $ERRS -gt 0 ]
then
	echo "$ERRS error(s)"
	exit 1
fi

#rm -f $SRVL $CLTL
exit 0
